; NV gfx driver

; mmio reg files
PRAMDAC		equ	mmio+0x00680000
PRAMIN		equ	mmio+0x00710000

; hw cursor regs
cursor		equ	PRAMIN +0xf800
cursor_pos	equ	PRAMDAC+0x0300


; > eax = 0
; > ecx = 0
; > dx = 0x03??
%macro init_gfx 0
; unlock ext regs
	mov	dl, 0xd4
	mov	al, 0x1f
	out	dx, al
	inc	edx
	mov	al, 0x57
	out	dx, al

; activate hw cursor
	mov	dword [cursor_pos], (YRES/2 << 16)+XRES/2

	dec	edx
	mov	al, 0x31
	out	dx, al
	inc	edx
	mov	al, 0xfd
	out	dx, al

; load hw cursor (12x16)
	mov	esi, arrow_cursor
	mov	edi, cursor
	mov	al, 16				; y counter
%%1:	mov	cl, 12*2/4			; 12 pixels per row (16 bpp)
rep	movsd
	add	edi, byte 20*2			; skip remaining 20 pixels in row
	dec	eax
	jnz	%%1
%endmacro


%macro set_cursor 0
%endmacro