%ifndef __SOS_INC__
%define __SOS_INC__


;______________________________________________________________________________
;
; gdt/idt
;______________________________________________________________________________
;

; descriptor type
D_TSS		equ	0x8900
D_INT		equ	0x8e00
D_TRAP		equ	0x8f00
D_DATA		equ	0x92cf
D_CODE		equ	0x98cf

D_DPL3		equ	0x6000
D_READ		equ	0x0200		; (code segs only)

D_USE16		equ	0xcf		; xor with D_DATA/D_CODE for 16 bit, 1 byte limit granularity


%macro desc 3
%ifid %00
%00		equ	$-gdt|(((%3)&D_DPL3) >> 13)
%endif
global ?fixD%%jloc
?fixD%%jloc:
		dw	%2
		dw	%3
		dd	%1
%endmacro


group image

%macro isr 1
%%addr:
section patch
		dd	0
		dd	idt+(%1)*8 wrt image
		dd	8
		desc	%%addr, CODE, D_INT
section code
%endmacro


;______________________________________________________________________________
;
; key codes
;______________________________________________________________________________
;
K_SHIFT		equ	0x01
K_CTRL		equ	0x02
K_ALT		equ	0x03

K_F1		equ	0x04
K_F2		equ	0x05
K_F3		equ	0x06
K_F4		equ	0x07

K_BACK		equ	0x08
K_TAB		equ	0x09

K_F5		equ	0x0a
K_F6		equ	0x0b
K_F7		equ	0x0c

K_ENTER		equ	0x0d

K_F8		equ	0x0e
K_F9		equ	0x0f
K_F10		equ	0x10
K_F11		equ	0x11
K_F12		equ	0x12

K_DEL		equ	0x13

K_ESC		equ	0x1b

K_SPACE		equ	0x20


%endif ; %ifdef __SOS_INC__